%% MichelsonHSI : measure an improved version of Michelson contrast 
function [HSI] = MichelsonHSI(i)

[x, y] = size(i);
% Computation of horizontal min,max
H_max = max(i(2:x-1,2:y-1),[],2);
H_min = min(i(2:x-1,2:y-1),[],2);
% Computation of vertical min,max
V_max = max(i(2:x-1,2:y-1),[],1);
V_min = min(i(2:x-1,2:y-1),[],1);

% Computation of mean values
H_mean_max = mean(H_max);
H_mean_min = mean(H_min);

V_mean_max = mean(V_max);
V_mean_min = mean(V_min);

% Michelson contrast for hsi format, vertical & horizontal
V_u = V_mean_max-V_mean_min;    
V_l = V_mean_max+V_mean_min;     
Vhsi_Cont = V_u/V_l;

H_u = H_mean_max-H_mean_min;    
H_l = H_mean_max+H_mean_min;     
Hhsi_Cont = H_u/H_l;
% Michelson contrast for hsi format
HSI = (Hhsi_Cont+Vhsi_Cont)/2;

% End of the function
end