%% hsvRuleOfThirds : estimate hsv histogram for each of the 9 patches of the rule of thirds grid
function [countFeat] = hsvRuleOfThirds(image, HSV, countFeat, fid)

[row, col, ~] = size(image);
StX = 1;
StY = 1;
EnX = floor(row/3);
EnY = floor(col/3);

% Image Hue, Saturation and Value
H = HSV(:,:,1);
S = HSV(:,:,2);
V = HSV(:,:,3);

Hf = cell(3,3);
Sf = cell(3,3);
Vf = cell(3,3);

for i = 1 : 3
    for j = 1 : 3
        Area = (EnX-StX)*(EnY-StY);
        Hf = H(StX : EnX,StY : EnY);
        Sf = S(StX : EnX,StY : EnY);
        Vf = V(StX : EnX,StY : EnY);
        SumHf = sum(Hf(:));
        SumSf = sum(Sf(:));
        SumVf = sum(Vf(:));
        Hftemp = SumHf/ Area;
        Sftemp = SumSf / Area;
        Vftemp = SumVf / Area;
        fprintf(fid,'%i: %0.6f %i: %0.6f %i: %0.6f ', countFeat, Hftemp, countFeat+1, Sftemp, countFeat+2, Vftemp);
        countFeat = countFeat + 3;
        
        StY = floor((col*j)/3);
        EnY = floor((col*(j+1))/3);
    end
    StY = 1;
    EnY = floor(col/3);
    StX = floor((row*i)/3);
    EnX = floor((row*(i+1))/3);
end

% End of the function
end
