%% rgb2xyz : convert rgb images to xyz color format
function [XYZ] = rgb2xyz(image)

% Transformation matrix
C = [
    3.40479 -1.537150 -0.498535
    -0.969256 1.875992 0.041556
    0.055648 -0.204043 1.057311];
Cinv = inv(C);

% Color components
image = double(image/255);
if size(image,3) == 3
    RGB = image;
elseif size(image,3) == 0
    RGB = R;
else
    error('Wrong number of arguments')
end

XYZ = zeros(size(image,1),size(image,2),size(image,3));
for i=1:3
    XYZ(:,:,i) = RGB(:,:,1)*Cinv(i,1) + RGB(:,:,2)*Cinv(i,2) + RGB(:,:,3)*Cinv(i,3);
end

end