%% CompositionMeasure : extract the appropriate features for composition assessment 
function CompositionMeasure( image, HSVimage,  fidCenter, fidRuleOfThirds, fidLandscape)

% The number of the windows
numOfWindows = 8;

boxes = runObjectness(image, numOfWindows); % default number of windows = 10
boxes = sortrows(boxes,5);

% Extract features in order to assess "fill the frame" composition rule
GridCenter( image, boxes, numOfWindows, fidCenter);
%--------------------------------------------------

% Extract features in order to assess "rule of thirds" composition rule
GridRuleOfThirds( image, boxes, numOfWindows, fidRuleOfThirds);
%--------------------------------------------------

% Extract features in order to assess "landscape" composition rule
GridLandscape( image, HSVimage, boxes, numOfWindows, fidLandscape);
%--------------------------------------------------

% End of the function
end

