%% distanceMeasures : distance measures (euclidean distance and angle)
function [ distanceFeatures ] = distanceMeasures( gridCenterX, gridCenterY , boxes, numOfWindows)
distanceFeatures = zeros(1,16);
temp = 1;
for i = 1 : numOfWindows
    % Compute the boxes properties
    xmin = boxes(i,1);
    ymin = boxes(i,2);
    xmax = boxes(i,3);
    ymax = boxes(i,4);
    
    % The center of the boxes
    centerX = xmin+(abs(xmax-xmin)/2);
    centerY = ymin+(abs(ymax-ymin)/2);
    
    % The euclidean distance between the center of boxes and the center of image
    eclDistance(1,:) = sqrt((gridCenterX-centerX).^2+(gridCenterY-centerY).^2);
    % The angle between the center of boxes and x axis(the center of image is considered as the center of axis)
    cosa(1,:) = (gridCenterX-centerX)./(sqrt((gridCenterX-centerX).^2+(gridCenterY-centerY).^2)+eps);
    
    distanceFeatures(1,temp:temp+1) = [eclDistance cosa];
    temp = temp + 2;
end

% End of the function
end

