%% intersectionArea : The spatial overlap between rule of thirds grids and object's boxes
function [ areaFeatures ] = intersectionArea( gridXmin, gridXmax, gridYmin, gridYmax , boxes, numOfWindows)

xmin = boxes(:,1);
ymin = boxes(:,2);
xmax = boxes(:,3);
ymax = boxes(:,4);

% The spatial overlap between rule of thirds grids and object's boxes
areaFeatures = zeros(1,8);
for i = 1 : numOfWindows
    % Initialize the corners of the intersection rectangles
    tempYmin = 0;
    tempYmax = 0;
    tempXmin = 0;
    tempXmax = 0;
    
    if ymax(i) >= gridYmin && ymax(i) <= gridYmax
        tempYmax =  ymax(i);
        if ymin(i) <= gridYmin
            tempYmin = gridYmin;
        end
    end
    if ymin(i) >= gridYmin && ymin(i) <= gridYmax
        tempYmin = ymin(i);
        if ymax(i) >= gridYmax
            tempYmax = gridYmax;
        end
    end
    if xmax(i) >= gridXmin && xmax(i) <= gridXmax
        tempXmax =  xmax(i);
        if xmin(i) <= gridXmin
            tempXmin = gridXmin;
        end
    end
    if xmin(i) >= gridXmin && xmin(i) <= gridXmax
        tempXmin = xmin(i);
        if xmax(i) >= gridXmax
            tempXmax = gridXmax;
        end
    end
    
    if ymin(i) <= gridYmin && ymax(i) >= gridYmax
        tempYmin = gridYmin;
        tempYmax = gridYmax;
    end
    
    if xmin(i) <= gridXmin && xmax(i) >= gridXmax
        tempXmin = gridXmin;
        tempXmax = gridXmax;
    end
    
    areaFeatures(1,i) = (abs(tempXmax-tempXmin)*abs(tempYmax-tempYmin))/(abs(gridXmax-gridXmin)*abs(gridYmax-gridYmin));
    
end

% End of the function
end

