%% WaveletRuleOfThirds : estimate the histogram of the edge map for each of the 9 patches of image
function [countFeat] = WaveletRuleOfThirds( waveletImage, ii, fid, countFeat )

[row, col, ~] = size(waveletImage);
StX = 1;
StY = 1;
EnX = floor(col/3);
EnY = floor(row/3);

% The number of bins that be computed 
Required_Bin_Num = 5;

% Fix width of bins
if ii == 1
    xmin = 0;
    xmax = 20;
    width = (xmax-xmin)/Required_Bin_Num; % bin width
    edges = xmin:width:xmax;
    edges(end) = xmax + 0.1;
elseif ii == 2
    xmin = 0;
    xmax = 50;
    width = (xmax-xmin)/Required_Bin_Num; % bin width
    edges = xmin:width:xmax;
    edges(end) = xmax + 0.1;
elseif ii == 3
    xmin = 0;
    xmax = 200;
    width = (xmax-xmin)/Required_Bin_Num; % bin width
    edges = xmin:width:xmax;
    edges(end) = xmax + 0.1;
end

for i = 1 : 3
    for j = 1 :3
        tempWavelet = waveletImage(StY:EnY,StX:EnX);
        
        % Bin contraction
        [histWavelet, ~] = histc(tempWavelet(:), edges);        % variable(:) put all values into a vector(1x(MxN))
        histWavelet(end) = [];                                  % The last bin is always zero so exclude it.
        histWavelet = histWavelet/(size(tempWavelet(:),1)+eps); % Normalization
        
        % Print the corresponding values
        for ii = 1 : Required_Bin_Num
            Bins = histWavelet(ii);
            
            if isnan(Bins)
                fprintf(fid,'%i: %0.6f ',countFeat, 0);
            else
                fprintf(fid,'%i: %0.6f ', countFeat, Bins);
            end
            countFeat = countFeat + 1;
        end
        
        StX = floor((col*j)/3);
        EnX = floor((col*(j+1))/3);
    end
    StX = 1;
    EnX = floor(col/3);
    StY = floor((row*i)/3);
    EnY = floor((row*(i+1))/3);
end
clear middlePoints pointSt pointX pointY

% End of the function
end
