%% resizeImage : resize the input image into the range of 640 * 480 px or 480* 640 px  
function [image] = resizeImage(image)
[height, width, ~] = size(image);

if (height >= width)
    scaling = 100*(height-480)/height;
    
    newHeight = 480;
    newWidth = width - (scaling*width /100);
    if(newWidth>640)
        newWidth = 640;
    end
    
else
    scaling = 100*(width-640)/width;
    
    newWidth = 640;
    newHeight = height - (scaling*height /100);
    if(newHeight>480)
        newHeight = 480;
    end
end

image = imresize(image,[newHeight newWidth]);

% End of the function
end
